import vl from 'vega-lite-api';
const hover = vl.selectSingle()
    .encodings('x')  // limit selection to x-axis value
    .on('mouseover') // select on mouseover events
    .nearest(true)   // select data point nearest the cursor
    .empty('none')
    .clear("mouseout");

//defining the line
const line = vl.markLine()
    .encode(
      vl
      .y()
      .fieldQ('CARS') //defining the field on Y axis
      .title('CARS REGISTERED'),
      
    vl
      .x()
      .fieldT('FISCAL_YEAR') //defining the field on Y axis
      .scale({ nice: true })
      .title('FISCAL_YEAR'));

//DEFINING THE CIRCLE on the line
const circle=
      vl.markCircle()
  .encode(
    vl
      .y()
      .fieldQ('CARS'),
    
    vl
      .x()
      .fieldT('FISCAL_YEAR')
      .scale({ nice: true }));

//defining the onhover functionality and placing the labels on the axes
const base = line.transform(vl.filter(hover));
const label = {align: 'left', dx: 5, dy: -5};
const white = {stroke: 'Red', strokeWidth: 1};

export const viz =
  vl.layer(circle,
    line,
    line.markCircle()
        .select(hover) // use as anchor points for selection
        .encode(vl.opacity().if(hover, vl.value(1)).value(0)),
    vl.markRule({color: 'Blue'})
        .transform(vl.filter(hover))
        .encode(vl.x().fieldT('FISCAL_YEAR')),
    base.markText(label, white).encode(vl.text().fieldQ('CARS')),
    base.markText(label).encode(vl.text().fieldQ('CARS')));
console.log('test')